<?php

require('include/glob.php');
require('include/muoribene.php');
require('include/sessionstart.php');

require('include/menu.php');
$menu['istanze']['href']=null;
$menu['istanze']['selected']=true;
buildmenu($menu);

require('include/myconn.php');

$dbg='';

use function mysqli_real_escape_string as myesc;

// praticamente una macro
function hspech($str) {
	return(htmlspecialchars($str,ENT_QUOTES|ENT_HTML5,'UTF-8'));
}

function nully($val,$fem,$filter,$ntext=null) {
	if (!is_null($val)) {
		if ($filter=='strip') {
			return(strip_tags($val,'<a><br><ol><ul><li><p><i><b><strong><em><small>'));
		} elseif ($filter=='htmlchars') {
			return(hspech($val));
		} elseif ($filter=='timestamp') {
			return(strftime('%a %d %b %Y, %T',$val));
		} elseif ($filter=='email') {
			return('<a href="mailto:'.strip_tags($val).'">'.strip_tags($val).'</a>');
		} elseif ($filter=='url') {
			return('<a href="'.strip_tags($val).'" target="_blank">'.strip_tags($val).'</a>');
		} elseif ($filter=='image') {
			return('<img src="'.str_replace('"','\\"',strip_tags($val)).'">');
		} elseif ($filter=='boolt') {
			if ($val)
				return('<span class="good">Si</span>');
			else
				return('<span class="bad">No</span>');
		} elseif ($filter=='boolf') {
			if ($val)
				return('<span class="bad">Si</span>');
			else
				return('<span class="good">No</span>');
		} else {
			return($val);
		}
	} else {
		if (is_null($ntext)) {
			if ($fem)
				return('<span class="nully">Non definita</span>');
			else
				return('<span class="nully">Non definito</span>');
			}
		else {
			return('<span class="nully">'.$ntext.'</span>');
		}
	}
}

function booly($pre,$val,$nottoobad=false,$invcol=false) {
	if ($val) {
		if (!$invcol) {
			$p='<p class="good">';
		} else {
			if (!$nottoobad) {
				$p='<p class="bad">';
			} else {
				$p='<p class="neut">';
			}
		}
		return($p.$pre.'SI</p>');
	} else {
		if (!$invcol) {
			if (!$nottoobad) {
				$p='<p class="bad">';
			} else {
				$p='<p class="neut">';
			}
		} else {
			$p='<p class="good">';
		}
		return($p.$pre.'NO</p>');
	}
}

$dbg.='<pre>'.print_r($_POST,1).'</pre>';

$cols=array(
	'New'=>array('name'=>'Nuova','type'=>'bool'),
	'Good'=>array('name'=>'Papabile','type'=>'bool'),
	'Chosen'=>array('name'=>'Scelta','type'=>'bool'),
	'Visible'=>array('name'=>'Visibile','type'=>'bool'),
	'Blacklisted'=>array('name'=>'Blacklistata','type'=>'bool'),
	'URI'=>array('name'=>'URI','type'=>'text'),
	'Title'=>array('name'=>'Titolo','type'=>'text'),
	'ShortDesc'=>array('name'=>'Descrizione breve','type'=>'text'),
	'LongDesc'=>array('name'=>'Descrizione lunga','type'=>'text'),
	'OurDesc'=>array('name'=>'Descrizione nostra','type'=>'text'),

	'PlaceID'=>array('name'=>'Località ⮞','type'=>'join','join'=>array(),'ord'=>false),
	'Places.Locality'=>array('name'=>'Località','type'=>'joini','join'=>array('Places ON Places.ID=Instances.PlaceID'),'subtype'=>'text'),

	'Email'=>array('name'=>'Email di contatto','type'=>'text'),
	'Software'=>array('name'=>'Software','type'=>'text'),
	'Version'=>array('name'=>'Versione','type'=>'text'),
	'UserCount'=>array('name'=>'Utenti','type'=>'int'),
	'StatusCount'=>array('name'=>'Stati','type'=>'int'),
	'DomainCount'=>array('name'=>'Istanze note','type'=>'int'),
	'ActiveUsersMonth'=>array('name'=>'Utenti attivi (mese)','type'=>'int'),
	'ActiveUsersHalfYear'=>array('name'=>'Utenti attivi (6 mesi)','type'=>'int'),
	'Thumb'=>array('name'=>'Logo','type'=>'text','search'=>false,'ord'=>false),
	'RegOpen'=>array('name'=>'Registrazioni aperte','type'=>'bool'),
	'RegReqApproval'=>array('name'=>'Approvazione registrazioni','type'=>'bool'),
	'MaxTootChars'=>array('name'=>'Limite caratteri','type'=>'int'),
	'AdmAccount'=>array('name'=>'Account admin','type'=>'text'),
	'AdmDisplayName'=>array('name'=>'Nome account admin','type'=>'text'),
	'AdmCreatedAt'=>array('name'=>'Data creazione account admin','type'=>'time'),
	'AdmURL'=>array('name'=>'Pagina dell’admin','type'=>'text','ord'=>false),
	'AdmAvatar'=>array('name'=>'Avatar admin','type'=>'text','search'=>false,'ord'=>false),
	'AdmNote'=>array('name'=>'Note dell’admin','type'=>'text'),

	'LangID'=>array('name'=>'Lingue dichiarate ⮞','type'=>'join','join'=>array('InstLangs ON InstLangs.InstID=Instances.ID'),'ord'=>false),
	'Languages.Code'=>array('name'=>'Lingue dichiarate','type'=>'joini','join'=>array('InstLangs ON InstLangs.InstID=Instances.ID','Languages ON Languages.ID=InstLangs.LangID'),'subtype'=>'text','ord'=>false),
	'InstLangs.LangID'=>array('name'=>'Lingua primaria dichiarata ⮞','type'=>'join','join'=>array('InstLangs ON InstLangs.InstID=Instances.ID'),'wheremore'=>'AND InstLangs.Pos=1','ord'=>false),
	'Languages.NameIT'=>array('name'=>'Lingua primaria dichiarata','type'=>'joini','join'=>array('InstLangs ON InstLangs.InstID=Instances.ID','Languages ON Languages.ID=InstLangs.LangID'),'subtype'=>'text','wheremore'=>'AND InstLangs.Pos=1'),

	'OurLangID'=>array('name'=>'Lingue impostate da noi ⮞','type'=>'join','join'=>array('InstOurLangs ON InstOurLangs.InstID=Instances.ID'),'ord'=>false),
	'OurLanguages.Code'=>array('name'=>'Lingue impostate da noi','type'=>'joini','join'=>array('InstOurLangs ON InstOurLangs.InstID=Instances.ID','Languages AS OurLanguages ON OurLanguages.ID=InstOurLangs.OurLangID'),'subtype'=>'text','ord'=>false),
	'InstOurLangs.OurLangID'=>array('name'=>'Lingua primaria impostata da noi ⮞','type'=>'join','join'=>array('InstOurLangs ON InstOurLangs.InstID=Instances.ID'),'wheremore'=>'AND InstOurLangs.Pos=1','ord'=>false),
	'OurLanguages.NameIT'=>array('name'=>'Lingua primaria impostata da noi','type'=>'joini','join'=>array('InstOurLangs ON InstOurLangs.InstID=Instances.ID','Languages AS OurLanguages ON OurLanguages.ID=InstOurLangs.OurLangID'),'subtype'=>'text','wheremore'=>'AND InstOurLangs.Pos=1'),

	'FinID'=>array('name'=>'Modalità di finanziamento ⮞','type'=>'join','join'=>array('InstFinancing ON InstFinancing.InstID=Instances.ID'),'ord'=>false),
	'Financing.Type'=>array('name'=>'Modalità di finanziamento','type'=>'joini','join'=>array('InstFinancing ON InstFinancing.InstID=Instances.ID','Financing ON Financing.ID=InstFinancing.FinID'),'subtype'=>'text'),
	'InstFinancing.FinID'=>array('name'=>'Modalità di finanziamento primaria ⮞','type'=>'join','join'=>array('InstFinancing ON InstFinancing.InstID=Instances.ID'),'wheremore'=>'AND InstFinancing.Pos=1','ord'=>false),
	'XFinancing.Type'=>array('name'=>'Modalità di finanziamento primaria','type'=>'joini','join'=>array('InstFinancing ON InstFinancing.InstID=Instances.ID','Financing AS XFinancing ON XFinancing.ID=InstFinancing.FinID'),'subtype'=>'text','wheremore'=>'AND InstFinancing.Pos=1'),

	'PolID'=>array('name'=>'Restrizioni sui contenuti ⮞','type'=>'join','join'=>array('InstPolicies ON InstPolicies.InstID=Instances.ID'),'ord'=>false),
	'Policies.Name'=>array('name'=>'Restrizioni sui contenuti','type'=>'joini','join'=>array('InstPolicies ON InstPolicies.InstID=Instances.ID','Policies ON Policies.ID=InstPolicies.PolID'),'subtype'=>'text'),
	'InstPolicies.PolID'=>array('name'=>'Restrizione sui contenuti primaria ⮞','type'=>'join','join'=>array('InstPolicies ON InstPolicies.InstID=Instances.ID'),'wheremore'=>'AND InstPolicies.Pos=1','ord'=>false),
	'XPolicies.Name'=>array('name'=>'Restrizione sui contenuti primaria','type'=>'joini','join'=>array('InstPolicies ON InstPolicies.InstID=Instances.ID','Policies AS XPolicies ON XPolicies.ID=InstPolicies.PolID'),'subtype'=>'text','wheremore'=>'AND InstPolicies.Pos=1'),

	'TagID'=>array('name'=>'Tags ⮞','type'=>'join','join'=>array('InstTags ON InstTags.InstID=Instances.ID'),'ord'=>false),
	'Tags.Name'=>array('name'=>'Tags','type'=>'joini','join'=>array('InstTags ON InstTags.InstID=Instances.ID','Tags ON Tags.ID=InstTags.TagID'),'subtype'=>'text'),
	'InstTags.TagID'=>array('name'=>'Tag primaria ⮞','type'=>'join','join'=>array('InstTags ON InstTags.InstID=Instances.ID'),'wheremore'=>'AND InstTags.Pos=1','ord'=>false),
	'XTags.Name'=>array('name'=>'Tag primaria','type'=>'joini','join'=>array('InstTags ON InstTags.InstID=Instances.ID','Tags AS XTags ON XTags.ID=InstTags.TagID'),'subtype'=>'text','wheremore'=>'AND InstTags.Pos=1'),

	/*'Statuses'=>array('name'=>'Stati ultima settimana','type'=>'joini','join'=>array('InstActivity ON InstActivity.InstID=Instances.ID'),'subtype'=>'int','selmore'=>'MAX(Week) AS maxweek'),
	'Logins'=>array('name'=>'Logins ultima settimana','type'=>'joini','join'=>array('InstActivity ON InstActivity.InstID=Instances.ID'),'subtype'=>'int','selmore'=>'MAX(Week) AS maxweek'),
	'Registrations'=>array('name'=>'Registrazioni ultima settimana','type'=>'joini','join'=>array('InstActivity ON InstActivity.InstID=Instances.ID'),'subtype'=>'int','selmore'=>'MAX(Week) AS maxweek'),*/
);

$types=array('bool','int','time','text','join','joini');

$fieldselopts='';
$ordfieldselopts='';
foreach ($cols as $key=>$val) {
	if (!array_key_exists('search',$val)) {
		if ($val['type']=='joini') {
			$fieldselopts.='<option value="'.$key.':'.$val['type'].':'.$val['subtype'].'">'.$val['name'].'</option>';
		} else {
			$fieldselopts.='<option value="'.$key.':'.$val['type'].':null">'.$val['name'].'</option>';
		}
	}
	if (!array_key_exists('ord',$val)) {
		if ($val['type']=='joini') {
			$ordfieldselopts.='<option value="'.$key.':'.$val['type'].':'.$val['subtype'].'">'.$val['name'].'</option>';
		} else {
			$ordfieldselopts.='<option value="'.$key.':'.$val['type'].':null">'.$val['name'].'</option>';
		}
	}
}

$i=0;
$jsaddrows='';
$jssetrows='';
$cp=count($_POST)/6; // /6 perché ogni "blocco" contiene 6 righe
$sels=array();
$joins=array();
$where='';
foreach ($_POST as $key=>$val) {
	if (preg_match('/^openpar-\d+/',$key)===1) {
		$i++;
		if (preg_match('/^\(+$/',$val)===1)
			$where.=$val;
		$jsaddrows.='addrow('.$i.',false);'.N;
		$jssetrows.='setrow('.$i.','.json_encode($val);
	}
	if (preg_match('/^fieldsel-\d+/',$key)===1 && preg_match('/^(.+):(.+):(.+)$/',$val,$buf)===1) {
		$col=$buf[1];
		$type=$buf[2];
		$subtype=$buf[3];
		if (array_key_exists($col,$cols) && in_array($type,$types)) {
			if (array_key_exists('wheremore',$cols[$col]))
				$where.='(';
			$where.=$col;
			if ($type=='join' || $type=='joini') {
				foreach ($cols[$col]['join'] as $join) {
					if (!in_array($join,$joins))
						$joins[]=$join;
				}
				if (array_key_exists('selmore',$cols[$col]) && !in_array($cols[$col]['selmore'],$sels))
					$sels[]=$cols[$col]['selmore'];
			}
			$jssetrows.=','.json_encode($val);
		} else {
			muoribene($dbg.'<br>Dati POST corrotti.<br>Puoi <a href="instances.php">riprovare</a> o <a href="index.php">tornare al login</a>.',true);
		}
	}
	if (preg_match('/^condsel-\d+/',$key)===1) {
		$where.=' '.$val.' ';
		$cond=$val;
		$jssetrows.=','.json_encode($val);
// nel caso qui sotto, valuesel e valueinp sono entrambi disabilitati (non ci sono in $_POST), quindi li riempio di introvabile e nulla
		if (preg_match('/^(IS NULL|IS NOT NULL)$/',$val)===1)
			$jssetrows.=',"NOMMITROVI!",""';
	}
	if (preg_match('/^valuesel-\d+/',$key)===1) {
		$where.=$val;
		if (array_key_exists('wheremore',$cols[$col]))
			$where.=' '.$cols[$col]['wheremore'].')';
		$jssetrows.=','.json_encode($val);
		$jssetrows.=',""';
	}
	if (preg_match('/^valueinp-\d+/',$key)===1) {
		if (preg_match('/^(LIKE|NOT LIKE)$/',$cond)===1)
			$where.='\'%'.myesc($link,$val).'%\'';
		else
			$where.='\''.myesc($link,$val).'\'';
		if (array_key_exists('wheremore',$cols[$col]))
			$where.=' '.$cols[$col]['wheremore'].')';
		$jssetrows.=',"NOMMITROVIHODETTO!"';
		$jssetrows.=','.json_encode($val);
	}
	if (preg_match('/^closepar-\d+/',$key)===1) {
		if (preg_match('/^\)+$/',$val)===1)
			$where.=$val;
		$jssetrows.=','.json_encode($val);
	}
	if (preg_match('/^andor-\d+/',$key)===1 && preg_match('/^(AND|OR)$/',$val)===1) {
		if ($i<$cp)
			$where.=' '.$val.' ';
		$jssetrows.=','.json_encode($val).');'.N;
	}
}
if ($jsaddrows!='') {
	$jsaddrows.='document.getElementById("filbut").value="Rimuovi tutti i criteri di ricerca";'.N;
	$jsaddrows.='synctai();'.N;
}

if (count($sels)>0)
	$sels=', '.implode(', ',$sels);
else
	$sels='';
if ($where!='')
	$where='WHERE '.$where;
if (count($joins)>0)
	$joins='LEFT JOIN '.implode(' LEFT JOIN ',$joins);
else
	$joins='';

$query='SELECT *, Instances.ID AS IID'.$sels.' FROM Instances '.$joins.' '.$where.' GROUP BY IID ORDER BY Instances.URI ASC LIMIT 50';
$dbg.='QUERONA: '.$query.'<br>'.N;
$tini=microtime(true);
$res=mysqli_query($link,$query)
	or muoribene($dbg.'<br>'.$query.': '.mysqli_error($link).'<br>'.'La query è fallita. <a href="instances.php">Resetta</a>.',true);
$dbg.='Durata esecuzione query: '.round(microtime(true)-$tini,4).' sec.<br>'.N;

if (mysqli_num_rows($res)<1) {
	$out='<p>Nessuna istanza da mostrare.</p>'.N;
} else {
	$out='';
	while ($row=mysqli_fetch_assoc($res)) {
		$out.='<table class="bigtab">'.N;
//		$out.='<thead><tr><th class="tdattr">Attributi</th><th>Info</th></thead>'.N;
		$out.='<tbody>'.N;
		$out.='<tr><td colspan="2" class="insthead">'.$row['URI'].' {'.$row['IID'].'}</td></tr>'.N;
		$attr=booly($cols['Blacklisted']['name'].': ',$row['Blacklisted'],false,true).N;
		$attr.=booly($cols['New']['name'].': ',$row['New'],true).N;
		$attr.=booly($cols['Good']['name'].': ',$row['Good']).N;
		$attr.=booly($cols['Chosen']['name'].': ',$row['Chosen']).N;
		$attr.=booly($cols['Visible']['name'].': ',$row['Visible']).N;
/*		$attr.=booly($cols['RegOpen']['name'].': ',$row['RegOpen']).N;
		$attr.=booly($cols['RegReqApproval']['name'].': ',$row['RegReqApproval'],true,true).N;*/
		$sres=mysqli_query($link,'SELECT * FROM InstChecks WHERE InstID='.$row['IID'].' ORDER BY Time DESC')
			or muoribene(mysqli_error($link),true);
		$csres=mysqli_num_rows($sres);
		if ($csres>0) {
			$bene=0;
			while ($srow=mysqli_fetch_assoc($sres)) {
				if ($srow['Status']==1)
					$bene++;
			}
			$width=str_replace(',','.',100/$csres*$bene);
			$attr.='<div class="colsectheader">Percentuale di risposta ai nostri check: '.round($width,1).'%</div>';
			$attr.='<div class="percbg"><div class="percfg" style="width:'.$width.'%;"></div></div>'.N;
			mysqli_data_seek($sres,0);
			$srow=mysqli_fetch_assoc($sres);
			$attr.='<div class="colsectcont">Ultimo check '.strftime('%e %b %Y, %T',$srow['Time']).': '.(($srow['Status']) ? '<span class="good">OK</span>' : '<span class="bad">KO</span>').'</div>';
		} else {
			$attr.='<div class="colsectheader">Percentuale di risposta ai nostri check</div>'.N;
			$attr.='<div class="colsectcont nully">Non disponibile (?!?!?!)</div>'.N;
		}
		$attr.='<div class="colsectheader">Attività delle ultime 12 settimane</div>'.N;
		$sres=mysqli_query($link,'SELECT SUM(Statuses) AS tstatuses, SUM(Logins) AS tlogins, SUM(Registrations) AS tregs FROM InstActivity WHERE InstID='.$row['IID'])
			or muoribene(mysqli_error($link),true);
		$tot=mysqli_fetch_assoc($sres);
		$sres=mysqli_query($link,'SELECT * FROM InstActivity WHERE InstID='.$row['IID'].' ORDER BY Week DESC')
			or muoribene(mysqli_error($link),true);
		if (mysqli_num_rows($sres)>0) {
			$attr.='<div class="colsectcont">Stati: '.$tot['tstatuses'].'<br>Accessi: '.$tot['tlogins'].'<br>Registrazioni: '.$tot['tregs'].'</div>'.N;
			while ($srow=mysqli_fetch_assoc($sres)) {
				$attr.='<div class="colsectcontb">'.strftime('%e %b %Y',$srow['Week']).'</div>'.N;
				($tot['tstatuses']==0) ? $width=0 : $width=str_replace(',','.',100/$tot['tstatuses']*$srow['Statuses']);
				$attr.='<div class="percstatuses" style="width:'.$width.'%;">'.$srow['Statuses'].'&nbsp;stati</div>'.N;
				($tot['tlogins']==0) ? $width=0 : $width=str_replace(',','.',100/$tot['tlogins']*$srow['Logins']);
				$attr.='<div class="perclogins" style="width:'.$width.'%;">'.$srow['Logins'].'&nbsp;accessi</div>'.N;
				($tot['tregs']==0) ? $width=0 : $width=str_replace(',','.',100/$tot['tregs']*$srow['Registrations']);
				$attr.='<div class="percregs" style="width:'.$width.'%;">'.$srow['Registrations'].'&nbsp;registrazioni</div>'.N;
			}
		} else {
			$attr.='<div class="colsectcont nully">Non disponibile</div>'.N;
		}
		$attr.='<div class="colsectheader">Hashtags più usati durante l’ultima settimana</div>'.N;
		$sres=mysqli_query($link,'SELECT * FROM InstTrends WHERE InstID='.$row['IID'].' ORDER BY Pos ASC')
			or muoribene(mysqli_error($link),true);
		if (mysqli_num_rows($sres)>0) {
			$attr.='<div class="colsectcont"><ol>'.N;
			while ($srow=mysqli_fetch_assoc($sres)) {
				$attr.='<li><a href="'.$srow['URL'].'">'.hspech($srow['Name']).'</a></li>'.N;
			}
			$attr.='</ol></div>'.N;
		} else {
			$attr.='<div class="colsectcont nully">Non disponibili</div>'.N;
		}
		$out.='<tr><td class="tdattr">'.$attr.'</td><td>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['URI']['name'].':</span> <a href="https://'.$row['URI'].'" target="_blank">'.$row['URI'].'</a></div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['Title']['name'].':</span> '.nully($row['Title'],false,'strip').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['Thumb']['name'].':</span> '.nully($row['Thumb'],true,'image').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['ShortDesc']['name'].':</span> '.nully($row['ShortDesc'],true,'strip').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['LongDesc']['name'].':</span> '.nully($row['LongDesc'],true,'strip').'</div>'.N;
// 'strip' o 'htmlent' per la descrizione nostra?
		$out.='<div class="baloo"><span class="ourfield">'.$cols['OurDesc']['name'].':</span> '.nully($row['OurDesc'],true,'strip').'</div>'.N;
		$out.='<div class="baloo"><span class="ourfield">'.$cols['Places.Locality']['name'].':</span> ';
		if (!is_null($row['PlaceID'])) {
			$sres=mysqli_query($link,'SELECT * FROM Places WHERE Places.ID='.$row['PlaceID'])
				or muoribene(mysqli_error($link),true);
			$srow=mysqli_fetch_assoc($sres);
			$out.=hspech($srow['Locality']).'</div>'.N;
		} else {
			$out.='<span class="nully">Non definita</span></div>'.N;
		}
		$sres=mysqli_query($link,'SELECT * FROM InstLangs LEFT JOIN Languages ON Languages.ID=LangID WHERE InstID='.$row['IID'].' ORDER BY Pos ASC')
			or muoribene(mysqli_error($link),true);
		if (mysqli_num_rows($sres)>0) {
			$i=0;
			$buf=array();
			while ($srow=mysqli_fetch_assoc($sres)) {
				$i++;
				$buf[]=$i.': '.hspech($srow['Code'].' ['.ucfirst(locale_get_display_name($srow['Code'])).']');
			}
			$out.='<div class="baloo"><span class="field">'.$cols['Languages.Code']['name'].':</span> '.implode('; ',$buf).'</div>'.N;
		} else {
			$out.='<div class="baloo"><span class="field">'.$cols['Languages.Code']['name'].':</span> <span class="nully">Non definite</span></div>'.N;
		}
		$sres=mysqli_query($link,'SELECT * FROM InstOurLangs LEFT JOIN Languages ON Languages.ID=OurLangID WHERE InstID='.$row['IID'].' ORDER BY Pos ASC')
			or muoribene(mysqli_error($link),true);
		if (mysqli_num_rows($sres)>0) {
			$i=0;
			$buf=array();
			while ($srow=mysqli_fetch_assoc($sres)) {
				$i++;
				$buf[]=$i.': '.hspech($srow['Code'].' ['.ucfirst(locale_get_display_name($srow['Code'],'it')).']');
			}
			$out.='<div class="baloo"><span class="ourfield">'.$cols['OurLanguages.Code']['name'].':</span> '.implode('; ',$buf).'</div>'.N;
		} else {
			$out.='<div class="baloo"><span class="ourfield">'.$cols['OurLanguages.Code']['name'].':</span> <span class="nully">Non definite</span></div>'.N;
		}
		$sres=mysqli_query($link,'SELECT * FROM InstFinancing LEFT JOIN Financing ON Financing.ID=FinID WHERE InstID='.$row['IID'].' ORDER BY Pos ASC')
			or muoribene(mysqli_error($link),true);
		if (mysqli_num_rows($sres)>0) {
			$i=0;
			$buf=array();
			while ($srow=mysqli_fetch_assoc($sres)) {
				$i++;
				$buf[]=$i.': '.hspech($srow['Type']);
			}
			$out.='<div class="baloo"><span class="ourfield">'.$cols['Financing.Type']['name'].':</span> '.implode('; ',$buf).'</div>'.N;
		} else {
			$out.='<div class="baloo"><span class="ourfield">'.$cols['Financing.Type']['name'].':</span> <span class="nully">Non definite</span></div>'.N;
		}
		$sres=mysqli_query($link,'SELECT * FROM InstPolicies LEFT JOIN Policies ON Policies.ID=PolID WHERE InstID='.$row['IID'].' ORDER BY Pos ASC')
			or muoribene(mysqli_error($link),true);
		if (mysqli_num_rows($sres)>0) {
			$i=0;
			$buf=array();
			while ($srow=mysqli_fetch_assoc($sres)) {
				$i++;
				$buf[]=$i.': '.hspech($srow['Name']);
			}
			$out.='<div class="baloo"><span class="ourfield">'.$cols['Policies.Name']['name'].':</span> '.implode('; ',$buf).'</div>'.N;
		} else {
			$out.='<div class="baloo"><span class="ourfield">'.$cols['Policies.Name']['name'].':</span> <span class="nully">Non definite</span></div>'.N;
		}
		$sres=mysqli_query($link,'SELECT * FROM InstTags LEFT JOIN Tags ON Tags.ID=TagID WHERE InstID='.$row['IID'].' ORDER BY Pos ASC')
			or muoribene(mysqli_error($link),true);
		if (mysqli_num_rows($sres)>0) {
			$i=0;
			$buf=array();
			while ($srow=mysqli_fetch_assoc($sres)) {
				$i++;
				$buf[]=$i.': '.hspech($srow['Name']);
			}
			$out.='<div class="baloo"><span class="ourfield">'.$cols['Tags.Name']['name'].':</span> '.implode('; ',$buf).'</div>'.N;
		} else {
			$out.='<div class="baloo"><span class="ourfield">'.$cols['Tags.Name']['name'].':</span> <span class="nully">Non definite</span></div>'.N;
		}
		$out.='<div class="baloo"><span class="field">'.$cols['Email']['name'].':</span> '.nully($row['Email'],true,'email').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['Software']['name'].':</span> '.nully($row['Software'],false,'strip').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['Version']['name'].':</span> '.nully($row['Version'],true,'strip').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['UserCount']['name'].':</span> '.nully($row['UserCount'],false,'strip').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['StatusCount']['name'].':</span> '.nully($row['StatusCount'],false,'strip').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['DomainCount']['name'].':</span> '.nully($row['DomainCount'],false,'strip').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['ActiveUsersMonth']['name'].':</span> '.nully($row['ActiveUsersMonth'],false,'strip').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['ActiveUsersHalfYear']['name'].':</span> '.nully($row['ActiveUsersHalfYear'],false,'strip').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['RegOpen']['name'].':</span> '.nully($row['RegOpen'],false,'boolt').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['RegReqApproval']['name'].':</span> '.nully($row['RegReqApproval'],false,'boolf').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['MaxTootChars']['name'].':</span> '.nully($row['MaxTootChars'],false,'strip','500').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['AdmAccount']['name'].':</span> '.nully($row['AdmAccount'],false,'strip').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['AdmDisplayName']['name'].':</span> '.nully($row['AdmDisplayName'],false,'strip').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['AdmCreatedAt']['name'].':</span> '.nully($row['AdmCreatedAt'],true,'timestamp').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['AdmURL']['name'].':</span> '.nully($row['AdmURL'],true,'url').'</div>'.N;
		$out.='<div class="baloo"><span class="field">'.$cols['AdmAvatar']['name'].':</span> '.nully($row['AdmAvatar'],false,'image').'</div>'.N;
		$out.='<div><span class="field">'.$cols['AdmNote']['name'].':</span> '.nully($row['AdmNote'],false,'strip').'</div>'.N;
		$out.='</td></tr>'.N;
		$out.='</tbody>'.N;
		$out.='</table>'.N;
	}
	$out.='<div class="bigtabfoot"></div>';
}

mysqli_close($link);

?>
<!DOCTYPE HTML>
<html lang="it">
<head>
<title>Mastodon Startpage Admin - Istanze</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="description" content="Admin pages for Mastodon Startpage">
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
<link rel="icon" type="image/png" href="imgs/icona-32.png" sizes="32x32">
<link rel="icon" type="image/png" href="imgs/icona-192.png" sizes="192x192">
<link rel="icon" type="image/png" href="imgs/icona-512.png" sizes="512x512">
<link rel="apple-touch-icon-precomposed" href="imgs/icona-180.png">
<script language="JavaScript" src="js/confirma.js?v=<?php echo($cjrand); ?>"></script>
<script language="JavaScript" src="js/alerta.js?v=<?php echo($cjrand); ?>"></script>
<link rel="stylesheet" type="text/css" href="theme.css?v=<?php echo($cjrand); ?>">
<script language="JavaScript">
<!--
function chulsh(el,sh) {
	if (sh)
		el.querySelector('ul').style.display='block';
	else
		el.querySelector('ul').style.display='none';
}
function ulsh(el,sh) {
	if (sh)
		el.style.display='block';
	else
		el.style.display='none';
}
function golang(lang) {
	var loc=document.location.href;
	loc=loc.replace(/#.*$/,'');
	loc=loc.replace(/\/$/,'');
	if (document.documentElement.lang=='en') {
		if (lang!='en')
			document.location.href=loc+'/'+lang;
	} else {
		if (lang!='en')
			document.location.href=loc.substr(0,loc.length-3)+'/'+lang;
		else
			document.location.href=loc.substr(0,loc.length-3);
	}
}

function shideplancia() {
	var plancia=document.getElementById('plancia');
	var plctrl=document.getElementById('plctrl');
	if (plancia.style.display=='block') {
		plancia.style.display='none';
		plctrl.innerHTML='Mostra plancia';
	} else {
		plancia.style.display='block';
		plctrl.innerHTML='Nascondi plancia';
	}
}

function truncsel(el) {
	var sel=document.getElementById(el), len=sel.length, i=0;
	for (i=len-1; i>=0; i--)
		sel.remove(i);
}
function addselopt(el,val,txt) {
	option=new Option(txt,val);
	el.add(option);
}
function inpdisif(index) {
	console.log('inpdisif index: '+index);
	var source=document.getElementById('condsel-'+index);
	var inp=document.getElementById('valueinp-'+index);
	var sel=document.getElementById('valuesel-'+index);
	var conds=['IS NULL','IS NOT NULL'];
	if (conds.includes(source.value)) {
		inp.disabled=true;
		sel.disabled=true;
	} else {
		if (inp.style.display!='none') inp.disabled=false;
		if (sel.style.display!='none') sel.disabled=false;
	}
}
function popusels(index,valselval) {
	console.log('popusels index: '+index);
	var key=document.getElementById('fieldsel-'+index).value;
	var type=key.replace(/^.*:(.*):.*$/,'$1');
	var subtype=key.replace(/^.*:.*:(.*)$/,'$1');
	key=key.replace(/^(.*):.*:.*$/,'$1');
	var condsel=document.getElementById('condsel-'+index);
	var valsel=document.getElementById('valuesel-'+index);
	var valinp=document.getElementById('valueinp-'+index);
	condsel.setAttribute('onchange','inpdisif('+index+');');
	if (type=='joini')
		type=subtype;
	if (type=='bool') {
		truncsel('condsel-'+index);
		addselopt(condsel,'IS','è');
		truncsel('valuesel-'+index);
		addselopt(valsel,'TRUE','vero');
		addselopt(valsel,'FALSE','falso');
		addselopt(valsel,'NOT NULL','definit@');
		addselopt(valsel,'NULL','non definit@');
		if (valselval!==false)
			selind('valuesel-'+index,valselval);
		valinp.style.display='none';
		valinp.disabled=true;
		valsel.style.display='block';
		valsel.disabled=false;
	} else if (type=='text') {
		truncsel('condsel-'+index);
		addselopt(condsel,'LIKE','contiene');
		addselopt(condsel,'NOT LIKE','non contiene');
		addselopt(condsel,'=','è uguale a');
		addselopt(condsel,'!=','è divers@ da');
		addselopt(condsel,'>=','è maggiore o uguale a');
		addselopt(condsel,'<=','è minore o uguale a');
		addselopt(condsel,'>','è maggiore di');
		addselopt(condsel,'<','è minore di');
		addselopt(condsel,'IS NOT NULL','è definit@');
		addselopt(condsel,'IS NULL','non è definit@');
		valsel.style.display='none';
		valsel.disabled=true;
		valinp.style.display='block';
		valinp.disabled=false;
	} else if (type=='int' || type=='time') {
		truncsel('condsel-'+index);
		addselopt(condsel,'>=','è maggiore o uguale a');
		addselopt(condsel,'<=','è minore o uguale a');
		addselopt(condsel,'>','è maggiore di');
		addselopt(condsel,'<','è minore di');
		addselopt(condsel,'=','è uguale a');
		addselopt(condsel,'!=','è divers@ da');
		addselopt(condsel,'IS NOT NULL','è definit@');
		addselopt(condsel,'IS NULL','non è definit@');
		valsel.style.display='none';
		valsel.disabled=true;
		valinp.style.display='block';
		valinp.disabled=false;
	} else if (type=='join') {
		truncsel('condsel-'+index);
		addselopt(condsel,'=','è uguale a');
		addselopt(condsel,'!=','è divers@ da');
		addselopt(condsel,'IS NOT NULL','è definit@');
		addselopt(condsel,'IS NULL','non è definit@');
		valsel.style.display='block';
		valsel.disabled=false;
		valinp.style.display='none';
		valinp.disabled=true;
		truncsel('valuesel-'+index);
		let xhr=new XMLHttpRequest();
		xhr.open('GET','instancesh.php?key='+key);
		xhr.responseType='json';
		xhr.send();
		xhr.onload=function() {
			let jarr=xhr.response;
			for (i=0; i<jarr.length; i++)
				addselopt(valsel,jarr[i][0],jarr[i][1]);
			console.log('valsel pronto!');
			if (valselval!==false)
				selind('valuesel-'+index,valselval);
		};
		xhr.onerror=function() {
			alert('Request failed');
		};
	} else {
		alert('Attenziò: non so che farmene del tipo "'+type+'": diglielo, al programmatore.');
	}
}
function addrow(index,refresh) {
	var table=document.getElementById('planciafil');
	var newrow=table.insertRow(index);
	var newcell0=newrow.insertCell(0);
	var newcell1=newrow.insertCell(1);
	var newcell2=newrow.insertCell(2);
	var newcell3=newrow.insertCell(3);
	var newcell4=newrow.insertCell(4);
	var newcell5=newrow.insertCell(5);
	var newcell6=newrow.insertCell(6);
	var newcell7=newrow.insertCell(7);
	newcell0.innerHTML='<select class="openpar"><option value="null"></option><option value="(">(</option><option value="((">((</option><option value="(((">(((</option></select>';
	newcell1.innerHTML='<select class="fieldsel"><?php echo($fieldselopts); ?></select>';
	newcell2.innerHTML='<select class="condsel"></select>';
	newcell3.innerHTML='<select class="valuesel" style="display:none;"></select><input type="text" class="valueinp" maxlength="256" style="display:none;">';
	newcell4.innerHTML='<select class="closepar"><option value="null"></option><option value=")">)</option><option value="))">))</option><option value=")))">)))</option></select>';
	newcell5.innerHTML='<select class="andor"><option value="AND">E</option><option value="OR">O</option></select>';
	newcell6.innerHTML='<img class="plus" src="imgs/plus.svg">';
	newcell7.innerHTML='<img class="minus" src="imgs/minus.svg">';
	if (refresh) {
		synctai();
		popusels(index,false);
	}
}
function synctai() {
	var i=0;
	var table=document.getElementById('planciafil');
	var nodes=table.querySelectorAll('.minus');
	var cnodes=nodes.length;
	for (i=0; i<cnodes; i++)
		// +1 sempre per via della row iniziale
		nodes[i].setAttribute('onclick','remrow('+(i+1)+');');
	nodes=table.querySelectorAll('.plus');
	for (i=0; i<cnodes; i++)
		// +2 perché la devi aggiungere dopo la corrente
		nodes[i].setAttribute('onclick','addrow('+(i+2)+',true);');
// da qui in poi faccio a scendere per non avere mai id e nomi duplicati
	cnodes--;
	nodes=table.querySelectorAll('.openpar');
	for (i=cnodes; i>-1; i--) {
		nodes[i].setAttribute('id','openpar-'+(i+1));
		nodes[i].setAttribute('name','openpar-'+(i+1));
	}
	nodes=table.querySelectorAll('.fieldsel');
	for (i=cnodes; i>-1; i--) {
		nodes[i].setAttribute('id','fieldsel-'+(i+1));
		nodes[i].setAttribute('name','fieldsel-'+(i+1));
		nodes[i].setAttribute('onchange','popusels('+(i+1)+',false);');
	}
	nodes=table.querySelectorAll('.condsel');
	for (i=cnodes; i>-1; i--) {
		nodes[i].setAttribute('id','condsel-'+(i+1));
		nodes[i].setAttribute('name','condsel-'+(i+1));
		nodes[i].setAttribute('onchange','inpdisif('+(i+1)+');');
	}
	nodes=table.querySelectorAll('.valuesel');
	for (i=cnodes; i>-1; i--) {
		nodes[i].setAttribute('id','valuesel-'+(i+1));
		nodes[i].setAttribute('name','valuesel-'+(i+1));
	}
	nodes=table.querySelectorAll('.valueinp');
	for (i=cnodes; i>-1; i--) {
		nodes[i].setAttribute('id','valueinp-'+(i+1));
		nodes[i].setAttribute('name','valueinp-'+(i+1));
	}
	nodes=table.querySelectorAll('.closepar');
	for (i=cnodes; i>-1; i--) {
		nodes[i].setAttribute('id','closepar-'+(i+1));
		nodes[i].setAttribute('name','closepar-'+(i+1));
	}
	nodes=table.querySelectorAll('.andor');
	for (i=cnodes; i>-1; i--) {
		nodes[i].setAttribute('id','andor-'+(i+1));
		nodes[i].setAttribute('name','andor-'+(i+1));
		nodes[i].disabled=false;
	}
	if (cnodes>=0)
		nodes[cnodes].disabled=true;
}
function selind(id,val) {
	var el=document.getElementById(id), i=0, found=false;
	while (!found && i<el.length) {
		if (el[i].value==val) {
			el.selectedIndex=i;
			found=true;
		}
		i++;
	}
	if (!found)
		console.log('"'+val+'" non è stato trovato in "'+id+'"');
}
function setrow(index,openparv,fieldselv,condselv,valueselv,valueinpv,closeparv,andorv) {
	selind('openpar-'+index,openparv);
	selind('fieldsel-'+index,fieldselv);
	popusels(index,valueselv);
	selind('condsel-'+index,condselv);
//	selind('valuesel-'+index,valueselv);
	document.getElementById('valueinp-'+index).value=valueinpv;
	if (condselv=='IS NULL' || condselv=='IS NOT NULL') {
		document.getElementById('valueinp-'+index).disabled=true;
		document.getElementById('valuesel-'+index).disabled=true;
	}
	selind('closepar-'+index,closeparv);
	selind('andor-'+index,andorv);
}
function remrow(index) {
	var table=document.getElementById('planciafil');
	table.deleteRow(index);
	synctai();
	if (table.rows.length<2)
		document.getElementById('filbut').value='Aggiungi criteri di ricerca';
}
function truncfil() {
	var table=document.getElementById('planciafil');
	while (table.rows.length>1)
		remrow(1);
}
function manfil() {
	var filbut=document.getElementById('filbut');
	var table=document.getElementById('planciafil');
	var crows=table.rows.length;
	if (crows<2) {
		addrow(1,true);
		filbut.value='Rimuovi tutti i criteri di ricerca';
	} else {
		confirma('Confermi di voler rimuovere tutti i criteri di ricerca?','truncfil();filbut.value=\'Aggiungi criteri di ricerca\'');
	}
}
function ckpar() {
	var i=0;
	var table=document.getElementById('planciafil');
	var nodes=table.querySelectorAll('.openpar');
	var cnodes=nodes.length;
	var opars=[];
	var cpars=[];
	for (i=0; i<cnodes; i++)
		opars.push(nodes[i].value);
	nodes=table.querySelectorAll('.closepar');
	for (i=0; i<cnodes; i++)
		cpars.push(nodes[i].value);
	var spars='';
	for (i=0; i<cnodes; i++) {
		if (opars[i]!='null') spars+=opars[i];
		if (cpars[i]!='null') spars+=cpars[i];
	}
	var opq=0, cpq=0, ok=true;
	for (i=0; i<spars.length; i++) {
		if (spars[i]=='(') {
			opq++;
		} else if (spars[i]==')') {
			cpq++;
		}
		if (cpq>opq)
			break;
	}
	if (opq!=cpq)
		ok=false;
	console.log(i+'/'+spars.length+': '+ok);
	return ok;
}
function ckf() {
	var emsg='';
	if (!ckpar()) emsg+='Qualcosa non va con le parentesi!<br>\n';
//	emsg+='Comunque NO!<br>\n';
	if (emsg=='') {
		var table=document.getElementById('planciafil');
		var crows=table.rows.length;
		if (crows>1)
			document.getElementById('andor-'+(crows-1)).disabled=false;
		document.getElementById('f').submit();
	} else {
		alerta(emsg);
	}
}
//-->
</script>
</head>
<body>

<nav>
<div id="hmenu">
<ul>
<?php echo($menuout); ?>
</ul>
<div id="rightdiv">
	<div id="plctrl" class="rlinks" onclick="shideplancia();">Mostra plancia</div>
	<div id="logout" class="rlinks"><a href="logout.php">Esci</a></div>
</div>
</nav>

<div id="popup">
<div id="inpopup">
<div id="popupcont">
...
</div>
</div>
</div>

<div id="footer">
<form action="edinst.php" name="addinst" method="post">
<table><tr><td>Aggiungi un’istanza:</td><td><input type="text" name="URI" maxlength="512"></td><td><input type="button" value="Vai" onClick="ckaif();"></td></tr></table>
</form>
</div>

<div id="debug">
<?php echo($dbg); ?>
</div>

<form method="post" id="f">
<div id="plancia">
<table id="planciafil" class="planciatab">
<tr><td colspan="8"><input type="button" id="filbut" value="Aggiungi criteri di ricerca" class="ctrlbut" onclick="manfil();"></td></tr>
</table>
<table id="planciaord" class="planciatab">
<tr><td colspan="8"><input type="button" id="ordbut" value="Aggiungi criteri di ordinamento" class="ctrlbut" onclick="alert('Aspetta!')"></td></tr>
</table>
<table id="planciaothers" class="planciatab">
<tr><td><input type="button" id="subbut" value="Applica" class="ctrlbut" onclick="ckf();"></td></tr>
</table>
</div>
</form>

<script language="JavaScript">
<!--
<?php
echo($jsaddrows);
echo($jssetrows);
?>
//-->
</script>

<div id="fullscreen">
<div id="middlerow">

<?php echo($out); ?>

</div>
</div>

</body>
</html>
